package cz.upol.jj1.lecture08;

import java.io.*;
import java.util.InputMismatchException;
import java.util.Scanner;

public class Main {


    public static void main(String[] args) {

        //byteStreams(true);
        //characterStreams(true);
        //bufferedStreams(true);
        //dataStreams(false);

        //scanner();

        readInput();
    }


    public static void byteStreams(boolean append) throws IOException {
        InputStream in = null;
        OutputStream out = null;

        //otevre vstup.txt pro cteni a vystup.txt pro zapis
        try {
            in = new FileInputStream("vstup.txt");
            out = new FileOutputStream("vystup.txt", append);  //apendovat nebo prepsat?
            int c;  // nacita se prave jeden byte

            // dokud je co cist v proudu nad vstupem
            while ((c = in.read()) != -1) {
                //tak to trikrat zapise do vystupu
                out.write(c);
                out.write(c);
                out.write(c);
            }
        } catch (IOException e) {  //kdyby selhalo cteni nebo zapis(soubor nelze otevrit, jina chyba)
            e.printStackTrace();
        } finally {
            if (in != null) {
                in.close();  //proud po skonceni prace s nim musime vzdy zavrit
            }
            if (out != null) {
                out.close();
            }
        }
    }

    public static void characterStreams(boolean append) throws IOException {

        Reader inputStream = null;  //misto InputStream je tady Reader
        Writer outputStream = null; // mistop OutputStream je tady Writer

        try {
            inputStream = new FileReader("vstup.txt");
            outputStream = new FileWriter("vystup.txt", append);

            int c; //nacita se jeen znak (muze byt vice nez byte - napr unicode)
            while ((c = inputStream.read()) != -1) {
                outputStream.write(c);
                outputStream.write(c);
                outputStream.write(c);
            }
        } finally {
            if (inputStream != null) {
                inputStream.close();
            }
            if (outputStream != null) {
                outputStream.close();
            }
        }
    }


    public static void bufferedStreams(boolean append) throws IOException {

        Reader inputStream = null;  //pouzivame znakovy reader
        Writer outputStream = null; // pouzivame znakovy writer

        BufferedReader bufferedInput = null;        //bufferovane znakove verze (existuji i bufferovane bytove verze BufferedInputStream a BufferedOutputStream)
        BufferedWriter bufferedOutput = null;       //nacitaji po vetsich usecich naraz - nacitani ze souboru po bytech/znacich je drahe

        try {
            inputStream = new FileReader("vstup.txt");
            outputStream = new FileWriter("vystup.txt", append);

            bufferedInput = new BufferedReader(inputStream);  //proudy obalime do bufferovanych verzi
            bufferedOutput = new BufferedWriter(outputStream);

            String line; //mimo jne umoznuji nacitat cele radky (nemusime)
            while ((line = bufferedInput.readLine()) != null) {
                bufferedOutput.write(line);
                bufferedOutput.write(line);
                bufferedOutput.write(line);
                bufferedOutput.newLine();
            }
        } finally {
            if (bufferedOutput != null) {
                bufferedOutput.flush();  //flush bufferovane verze (proved zapis bufferu do cile)
            }
            if (inputStream != null) {
                inputStream.close();
            }
            if (outputStream != null) {
                outputStream.close();
            }
        }
    }

    public static void dataStreams(boolean append) throws IOException {
        InputStream inputStream = null;  //pouzivame bytovy input
        OutputStream outputStream = null; // pouzivame bytovy output

        BufferedInputStream bufferedInput = null;        //bufferujeme vstup i vystp
        BufferedOutputStream bufferedOutput = null;

        DataInput dataReader = null;
        DataOutput dataWriter = null;

        try {
            outputStream = new FileOutputStream("data");
            bufferedOutput = new BufferedOutputStream(outputStream);
            dataWriter = new DataOutputStream(bufferedOutput);

            String[] slovo = {"retezec", "olej", "repete"};  // co budeme zapisovat/nacitat
            int[] pocetPismen = {7, 4, 6};
            int[] pocetE = {3, 1, 3};

            for (int i = 0; i < slovo.length; i++) {
                dataWriter.writeUTF(slovo[i]);       //zapisovani
                dataWriter.writeInt(pocetPismen[i]);
                dataWriter.writeInt(pocetE[i]);
            }
            bufferedOutput.flush();
            outputStream.close();


            inputStream = new FileInputStream("data");
            bufferedInput = new BufferedInputStream(inputStream);
            dataReader = new DataInputStream(bufferedInput);
            try {
                while (true) {
                    String s = dataReader.readUTF();   //nacitani - metody jsou 1 ku 1
                    int pP = dataReader.readInt();      // poradi resi programator.
                    int pE = dataReader.readInt();
                    System.out.println("Nacetli jsme " + s + " s " + pP + " pismeny a " + pE + "e-cky.");
                }
            } catch (EOFException e) {
                System.out.println("A soubor skoncil."); // v implementacich se pocita s resenim konce coubory pomoco EOFException
            }
        } finally {

            if (bufferedInput != null) {
                bufferedInput.close();  //zavre i stream, nad kterym je
            }
            if (outputStream != null) {
                outputStream.close();  //anebo muzu zavrit primo ten
            }
        }
    }

    public static void scanner() {
        //nacitani dat po tokenech (separator: white-space, lze nastavit jinak)
        Scanner s = null;

        try {
            s = new Scanner(new BufferedReader(new FileReader("vstup.txt")));
            while (s.hasNext()) {
                System.out.println(s.next());
                // mame i s.nextBoolean(), s.nextInt(), s.nextBigDecimal(), ... a jejich has verze
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } finally {
            if (s != null) {
                s.close();
            }
        }
    }


    public static void readInput() {
        //do scanneru muzete zabalit i vstup
        Scanner scanner = new Scanner(System.in);
        System.out.print("Zadejte slovo prosim");
        int slovo;
        try {
            slovo = scanner.nextInt();
            System.out.println(slovo);
        } catch (InputMismatchException ex) {
            System.out.println("Zajimava volba. Nevim, co s tim ...");

        }
        scanner.close();
    }

}


